[From nobody Sun Jan  9 16:11:39 2022
From: gitosis@osmocom.org
Precedence: list
To: osmocom-commitlog@lists.osmocom.org
Date: Tue, 2 Sep 2014 08:09:28 GMT
Message-ID: &lt;201409020809.s8289ScB031323@git.osmocom.org&gt;
Subject: openbsc.git branch master updated. 0.13.0-615-g5f4ef32
Message: 10

This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project &quot;The OpenBSC GSM Base Station Controller (+MSC/HLR/SGSN)&quot;.

The branch, master has been updated
       via  5f4ef321a62a3a6aadc6a815f7f25d167a197911 (commit)
       via  28fe98891fbe6475164f508790d19b4b06a88810 (commit)
       via  4b663ac34a993cb1f1aa8e993dfc37bcb6841123 (commit)
       via  299389a99fd7f839c3953a2cb48394b6679a6c84 (commit)
       via  46f1d6fddb422871eec22951dd04b936ffa79c3a (commit)
       via  48bb3a37da6d0c9257b5cbb7bd2c6816b4ec5ab0 (commit)
      from  e3283ec3eb8d74423694ff5d54838ca6205f6991 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
http://cgit.osmocom.org/openbsc/commit/?id=5f4ef321a62a3a6aadc6a815f7f25d167a197911

commit 5f4ef321a62a3a6aadc6a815f7f25d167a197911
Author: Jacob Erlbeck &lt;jerlbeck@sysmocom.de&gt;
Date:   Fri Aug 22 17:10:01 2014 +0200

    gbproxy: Implement IMSI acquisition
    
    To modify or route messages based on the IMSI the latter must be known
    when the action shall take place.
    
    This patch modifies the gbproxy to optionally retain and enqueue
    messages from the MS while initiating an identification procedure.
    Further message processing of the LLC PTP link towards the SGSN will
    be done, when the identity of the MS has been acquired.
    
    Note that the N(U) of the LLC GMM SAPI are not adjusted, so it is
    possible that adjacent messages of a single LLC link arriving either
    at the BSS or the SGSN have the same N(U) and might get discarded,
    leading to retransmissions and additional delay.
    
    Note also that retransmissions and packet loss are not yet handled
    explicitely. If for instance the generated IDENT REQ gets lost, the
    gbproxy will not act on its own. In this case, the MS will time out
    and eventually resend the Attach Request on which the gbproxy will
    act exactly like before (thus having two Attach Req messages in its
    queue, which will both be sent after the Ident Resp arrives).
    
    This has been tested successfully with an E71, needing one
    retransmission by the SGSN due to an N(U) collision.
    
    Ticket: OW#1261
    Sponsored-by: On-Waves ehf

http://cgit.osmocom.org/openbsc/commit/?id=28fe98891fbe6475164f508790d19b4b06a88810

commit 28fe98891fbe6475164f508790d19b4b06a88810
Author: Jacob Erlbeck &lt;jerlbeck@sysmocom.de&gt;
Date:   Tue Aug 26 13:33:36 2014 +0200

    gbproxy/test: Add a test for IMSI acquisition
    
    This patch copies test_gbproxy_ptmsi_patching to
    test_gbproxy_imsi_acquisition as a base for a later test for IMSI
    acquisition (which is not yet implemented). The idea behind this is
    to make the different behaviour visible in the ok file without
    compromising the P-TMSI test.
    
    Sponsored-by: On-Waves ehf

http://cgit.osmocom.org/openbsc/commit/?id=4b663ac34a993cb1f1aa8e993dfc37bcb6841123

commit 4b663ac34a993cb1f1aa8e993dfc37bcb6841123
Author: Jacob Erlbeck &lt;jerlbeck@sysmocom.de&gt;
Date:   Thu Aug 21 15:07:11 2014 +0200

    gbproxy: Create STATUS message with original PDU
    
    Currently when patching is enabled and an error happens when
    receiving a message from the SGSN, the patched message is sent back
    with the PDU_IN_ERROR IE.
    
    This patch modifies gbprox_rx_sig_from_sgsn() to copy the message
    before it is patched, so that the original message can be used with
    the STATUS message. gbprox_rx_ptp_from_sgsn() does all checks before
    the message is patched, so copying is not necessary.
    
    Since gbprox_rx_sig_from_sgsn() is not called for BSSGP UNITDATA
    messages and the msgb is already been copied in the gbprox_relay2peer
    function, the relative performance impact is expected to be low.
    
    Note that the PDU IE of STATUS messages received from an MS and
    forwarded to the SGSN will not be patched. STATUS messages from the
    SGSN are only logged and not forwarded to the MS.
    
    Sponsored-by: On-Waves ehf

http://cgit.osmocom.org/openbsc/commit/?id=299389a99fd7f839c3953a2cb48394b6679a6c84

commit 299389a99fd7f839c3953a2cb48394b6679a6c84
Author: Jacob Erlbeck &lt;jerlbeck@sysmocom.de&gt;
Date:   Thu Aug 21 16:34:18 2014 +0200

    gbproxy/test: Test patching BSSGP SUSPEND/LLC-DISCARDED
    
    Currently messages like these with a TLLI IE (BSSGP) are not
    tested (properly) with TLLI patching.
    
    This patch extends the send_bssgp_suspend* functions to accept a
    TLLI as argument and adds the send_bssgp_llc_discarded function.
    These are then used in test_gbproxy_ptmsi_patching() with a valid
    TLLI.
    
    Note that the TLLI IE patching doesn't work currently.
    
    Sponsored-by: On-Waves ehf

http://cgit.osmocom.org/openbsc/commit/?id=46f1d6fddb422871eec22951dd04b936ffa79c3a

commit 46f1d6fddb422871eec22951dd04b936ffa79c3a
Author: Jacob Erlbeck &lt;jerlbeck@sysmocom.de&gt;
Date:   Thu Aug 21 13:45:04 2014 +0200

    gbproxy: Move PTP message handling into separate functions
    
    This patch adds gbprox_rx_data_from_sgsn() and
    gbprox_rx_ptp_from_bss() which contain the PTP message processing
    of gbprox_rcvmsg(). The calls to gbprox_process_bssgp_ul() are moved
    from gbprox_relay2sgsn() to gbprox_rx_ptp_from_bss() and
    gbprox_rx_sig_from_bss().
    
    The goal is, to do all patching (and calls to gbprox_process_bssgp_*)
    from within the gbprox_rx_* functions. Doing the patching from within
    gbprox_relay2sgsn has the drawback, that the patching code cannot
    call gbprox_relay2sgsn() which is needed if a single message shall
    trigger a sequence of messages.
    
    Sponsored-by: On-Waves ehf

http://cgit.osmocom.org/openbsc/commit/?id=48bb3a37da6d0c9257b5cbb7bd2c6816b4ec5ab0

commit 48bb3a37da6d0c9257b5cbb7bd2c6816b4ec5ab0
Author: Jacob Erlbeck &lt;jerlbeck@sysmocom.de&gt;
Date:   Mon Sep 1 11:55:11 2014 +0200

    gbproxy: Remove nonnull attributes
    
    The compiler also uses this attribute for code elimination. If the
    nonnull attribute has been given erroneously for an parameter, that
    is later been checked against NULL, this check is removed silently
    by the gcc if optimization is enabled. This can lead to hard-to-find
    segmentation violation faults.
    
    To be on the safe side, this patch removes all uses of the nonnull
    attribute in openbsc.
    
    Compiler:
      - gcc 4.8.2 (Ubuntu 4.8.2-19ubuntu1): no warning, segfault
      - clang 3.4 (3.4-1ubuntu3): no warning, no segfault, asm ok
    
    Example:
      /* foo.c */
      int f(int* p) __attribute((nonnull));
      int f(int *p) {
          if (!p)
              return 0;
    
          return *p;
      }
    
      /* main.c */
      int f(int* p) __attribute((nonnull));
      int g () {
          return f(arg);
      }
    
      int main() {
          return g(NULL);
      }
    
    When these files are compiled into an executable, no warnungs are
    issued but it will fail with a segfault when -O2 is used (unless LTO
    is active).
    
    Compiler output (gcc -O2):
      int f(int *p) {
        0:  8b 44 24 04             mov    0x4(%esp),%eax
        4:  8b 00                   mov    (%eax),%eax
        6:  c3                      ret
      }
    
    Sponsored-by: On-Waves ehf

-----------------------------------------------------------------------

Summary of changes:
 openbsc/include/openbsc/gb_proxy.h      |  30 +-
 openbsc/include/openbsc/gprs_gb_parse.h |   9 +-
 openbsc/src/gprs/gb_proxy.c             | 322 ++++++++++++---
 openbsc/src/gprs/gb_proxy_tlli.c        |   2 +
 openbsc/src/gprs/gb_proxy_vty.c         |  24 ++
 openbsc/src/gprs/gprs_gb_parse.c        |  20 +-
 openbsc/tests/gbproxy/gbproxy_test.c    | 324 ++++++++++++++-
 openbsc/tests/gbproxy/gbproxy_test.ok   | 688 +++++++++++++++++++++++++++++---
 8 files changed, 1285 insertions(+), 134 deletions(-)


hooks/post-receive
-- 
The OpenBSC GSM Base Station Controller (+MSC/HLR/SGSN)


]